import { __rest, __assign } from 'tslib';
import { jsxs, jsx } from 'react/jsx-runtime';
import React from 'react';
import ReactDOM from 'react-dom';
import classNames from 'classnames';
import _isFunction from 'lodash/isFunction';
import _includes from 'lodash/includes';
import { ReactComponent } from '@netapp/icons/ic_external_link.svg';
import { ButtonLoadingOverlay } from './ButtonLoadingOverlay.js';
import useButtonContentPopover from './useButtonContentPopover.js';
import styles from './Button.module.scss.js';
import { Typography } from '../Typography/index.js';

var Button = React.forwardRef(function (_a, ref) {
  var _b;
  var Component = _a.Component,
    _c = _a.variant,
    variant = _c === void 0 ? 'primary' : _c,
    isThin = _a.isThin,
    isDisabled = _a.isDisabled,
    isHovered = _a.isHovered,
    isLoading = _a.isLoading,
    _d = _a.loadingProps,
    loadingProps = _d === void 0 ? {} : _d,
    Icon = _a.icon,
    className = _a.className,
    children = _a.children,
    title = _a.title,
    props = __rest(_a, ["Component", "variant", "isThin", "isDisabled", "isHovered", "isLoading", "loadingProps", "icon", "className", "children", "title"]);
  var hasIcon = variant !== 'icon' && Icon;
  var hasLoading = _includes(['primary', 'secondary'], variant) && isLoading;
  var _e = useButtonContentPopover({
      hasTitleAttribute: !!title,
      isSolidButton: _includes(['primary', 'secondary'], variant)
    }),
    contentRef = _e.contentRef,
    contentPopoverIsVisible = _e.contentPopoverIsVisible,
    contentPopoverProps = _e.contentPopoverProps;
  return jsxs(Typography, __assign({
    Component: Component || 'button',
    variant: 'Semibold_14',
    ref: ref
  }, props, {
    disabled: isDisabled,
    className: classNames(styles.base, className, styles[variant], (_b = {}, _b[styles['has-interaction']] = _isFunction(props === null || props === void 0 ? void 0 : props.onClick), _b[styles['has-icon']] = hasIcon, _b[styles['hovered']] = isHovered && !isDisabled && !(props === null || props === void 0 ? void 0 : props.disabled), _b[styles['small']] = isThin, _b[styles['disabled']] = isDisabled || (props === null || props === void 0 ? void 0 : props.disabled), _b[styles['loading']] = hasLoading, _b))
  }, {
    children: [hasIcon && jsx(Icon, {
      className: styles['left-icon']
    }), children && jsxs("span", __assign({
      className: styles.content,
      ref: contentRef
    }, {
      children: [children, contentPopoverIsVisible && ReactDOM.createPortal(jsx("div", __assign({}, contentPopoverProps, {
        children: title || children
      })), document.body)]
    })), variant === 'link' && jsx(ReactComponent, {
      className: styles['link-icon']
    }), hasLoading && jsx(ButtonLoadingOverlay, __assign({}, loadingProps))]
  }));
});

export { Button };
//# sourceMappingURL=index.js.map
