import { __assign } from 'tslib';
import React from 'react';
import usePopover from '../../hooks/usePopover.js';
import styles from './Button.module.scss.js';

var useButtonContentPopover = function (_a) {
  var hasTitleAttribute = _a.hasTitleAttribute,
    isSolidButton = _a.isSolidButton;
  var contentRef = React.useRef(null);
  var _b = React.useState(hasTitleAttribute),
    showContentPopover = _b[0],
    setShowContentPopover = _b[1];
  var _c = usePopover(__assign({
      trigger: 'hover',
      placement: 'bottom-start',
      offsetTop: 4
    }, isSolidButton ? {
      offsetLeft: 12
    } : {})),
    setPopoverRef = _c.setPopoverRef,
    getPopoverProps = _c.getPopoverProps,
    setContainerRef = _c.setContainerRef,
    containerRef = _c.containerRef,
    isVisible = _c.isVisible;
  React.useLayoutEffect(function () {
    var _a, _b;
    if (!hasTitleAttribute && (contentRef === null || contentRef === void 0 ? void 0 : contentRef.current)) {
      var hasOverflow = ((_a = contentRef === null || contentRef === void 0 ? void 0 : contentRef.current) === null || _a === void 0 ? void 0 : _a.scrollWidth) > ((_b = contentRef === null || contentRef === void 0 ? void 0 : contentRef.current) === null || _b === void 0 ? void 0 : _b.clientWidth);
      if (hasOverflow && !showContentPopover) {
        setShowContentPopover(true);
        if (!containerRef) {
          setContainerRef(contentRef === null || contentRef === void 0 ? void 0 : contentRef.current);
        }
      }
      if (!hasOverflow && showContentPopover) {
        setShowContentPopover(false);
      }
    }
    if (hasTitleAttribute && !containerRef && (contentRef === null || contentRef === void 0 ? void 0 : contentRef.current)) {
      setContainerRef(contentRef === null || contentRef === void 0 ? void 0 : contentRef.current);
    }
  }, [hasTitleAttribute, containerRef, contentRef, showContentPopover, setShowContentPopover]);
  return {
    contentPopoverProps: getPopoverProps({
      className: styles['content-tooltip'],
      ref: setPopoverRef
    }),
    contentRef: contentRef,
    contentPopoverIsVisible: showContentPopover && isVisible
  };
};

export { useButtonContentPopover as default };
//# sourceMappingURL=useButtonContentPopover.js.map
