import { __rest, __makeTemplateObject, __assign } from 'tslib';
import { jsx, jsxs, Fragment } from 'react/jsx-runtime';
import React from 'react';
import _size from 'lodash/size';
import _get from 'lodash/get';
import _map from 'lodash/map';
import _max from 'lodash/max';
import _includes from 'lodash/includes';
import classNames from 'classnames';
import { css } from '@emotion/css';
import styles from './ButtonGroup.module.scss.js';

var ButtonGroup = function (_a) {
  var className = _a.className;
    _a.style;
    var children = _a.children,
    props = __rest(_a, ["className", "style", "children"]);
  var childrenArray = React.Children.toArray(children);
  var buttonsRef = React.useRef([]);
  var _b = React.useState(),
    childrenWidth = _b[0],
    setChildrenWidth = _b[1];
  var childrenCount = _size(childrenArray);
  var customClass = React.useMemo(function () {
    if (childrenWidth && childrenWidth > 152) {
      return css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        --button-min-width: ", "px;\n      "], ["\n        --button-min-width: ", "px;\n      "])), childrenWidth);
    }
  }, [childrenWidth]);
  React.useEffect(function () {
    if (_size(buttonsRef.current) === childrenCount) {
      var widestButtonWidth_1 = _max(_map(buttonsRef.current,
      // @ts-ignore
      function (button) {
        return (button === null || button === void 0 ? void 0 : button.offsetWidth) || 0;
      }));
      setChildrenWidth(function (width) {
        if (width !== widestButtonWidth_1) {
          return widestButtonWidth_1;
        }
        return width;
      });
    }
  }, [buttonsRef.current]);
  return jsx("div", __assign({
    className: classNames(styles.base, customClass, className)
  }, props, {
    children: React.Children.map(childrenArray, function (child, index) {
      var _a;
      var nextButtonVariant = index < childrenCount && _get(childrenArray, "".concat(index + 1, "].props.variant"), 'primary');
      return jsxs(Fragment, {
        children: [React.cloneElement(child, {
          className: classNames(styles.child, _get(child, 'props.className')),
          // @ts-ignore
          ref: function (el) {
            return buttonsRef.current[index] = el;
          }
        }), nextButtonVariant && jsx("div", {
          className: classNames(styles.divider, (_a = {}, _a[styles['with-space']] = _includes(['primary', 'secondary', 'icon'], nextButtonVariant), _a[styles['with-border']] = _includes(['link', 'text'], nextButtonVariant), _a))
        })]
      });
    })
  }));
};
var templateObject_1;

export { ButtonGroup };
//# sourceMappingURL=index.js.map
