import React from 'react';
import { PopoverConfig } from '../../hooks/usePopover';
import { ButtonProps } from '../Button';
import { ButtonDropdownConfig } from './useButtonDropdown';
export interface ButtonWithDropdownProps extends Omit<ButtonProps<'button'>, 'Component' | 'ref' | 'variant'> {
    /** Open dropdown by default */
    isActive?: boolean;
    /** Trigger that toggle dropdown */
    trigger?: PopoverConfig['trigger'];
    /** Position of dropdown */
    placement?: 'bottom' | 'bottom-start' | 'bottom-end';
    /** Button dropdown style variation */
    variant?: 'primary' | 'secondary' | 'icon';
    /** Props for items (button|a) inside dropdown. Recommended to define them outside a component or to useMemo to memoize them. */
    items: ButtonProps<'button' | 'a'>[];
    /** Additional config for dropdown */
    dropdownConfig?: Omit<ButtonDropdownConfig, 'items' | 'isDisabled' | 'isActive' | 'trigger' | 'placement'> | undefined;
}
export declare const ButtonWithDropdown: React.FC<ButtonWithDropdownProps>;
