import React from 'react';
import { PopoverConfig } from '../../hooks/usePopover';
type PropsToOmit = 'offsetTop' | 'offsetLeft' | 'popperOptions' | 'interactive' | 'defaultVisible';
export type ButtonDropdownConfig = Omit<PopoverConfig, PropsToOmit> & {
    /** Button dropdown content class */
    className?: string;
    /** Button dropdown is active */
    isActive?: boolean;
    /** Button is in disabled state */
    isDisabled?: boolean;
};
declare const useButtonDropdown: (config: ButtonDropdownConfig) => {
    onItemClick: () => void;
    isDropdownActive: boolean;
    setButtonRef: React.Dispatch<React.SetStateAction<HTMLElement | null>>;
    dropdownProps: {
        'data-popper-interactive': boolean | undefined;
        style: React.CSSProperties;
    };
};
export default useButtonDropdown;
