import React, { ReactNode } from 'react';
export type CheckboxVariant = 'default' | 'tableCheckbox' | 'tableHeader';
export interface CheckboxProps extends Omit<React.HTMLAttributes<HTMLInputElement>, 'onChange'> {
    /** Checked or Unchecked  */
    isChecked: boolean;
    /** Checkbox variant */
    variant?: CheckboxVariant;
    /** Disables the checkbox */
    isDisabled?: boolean;
    /** Partial selection state */
    isPartial?: boolean;
    /** error state */
    isError?: boolean;
    /** custom className */
    className?: string;
    /** menu options for table header */
    menuOptions?: Array<{
        label: string;
        value?: string;
        isDisabled?: boolean;
        isActive?: boolean;
        onClick?: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    }>;
    /** callback called on change and user can use event as second argument */
    onChange?: (newValue: boolean, e: React.FormEvent<HTMLInputElement>) => void;
    /** Children */
    children?: ReactNode;
}
export declare const Checkbox: ({ isChecked, className, onChange, isDisabled, children, isPartial, isError, variant, menuOptions, ...rest }: CheckboxProps) => JSX.Element;
