import { __rest, __assign } from 'tslib';
import { jsxs, jsx, Fragment } from 'react/jsx-runtime';
import { useState } from 'react';
import classNames from 'classnames';
import styles from './Checkbox.module.scss.js';
import { Popover } from '../Popover/index.js';
import { Typography } from '../Typography/index.js';

var CheckboxContainer = function () {
  return jsxs("svg", __assign({
    className: styles['checkbox-container'],
    width: "16",
    height: "16",
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, {
    children: [jsx("rect", {
      className: styles['empty-checkbox'],
      x: "0.5",
      y: "0.5",
      width: "15",
      height: "15",
      rx: "1.5",
      stroke: "var(--Grey600)"
    }), jsx("rect", {
      className: styles['selected-background'],
      width: "16",
      height: "16",
      rx: "2",
      fill: "var(--Primary_Blue)"
    }), jsx("path", {
      d: "M6.99524 11.7848C6.60411 12.1789 5.96677 12.1789 5.57564 11.7848L2.59996 8.78628C2.26787 8.45165 2.26787 7.9118 2.59996 7.57717C2.93532 7.23924 3.48165 7.23885 3.81749 7.57631L6.28544 10.0562L12.1786 4.11782C12.5161 3.77774 13.0663 3.77872 13.4026 4.12C13.7336 4.45593 13.7327 4.99566 13.4005 5.3304L6.99524 11.7848Z",
      fill: "var(--White)",
      className: styles['on-path']
    }), jsx("rect", {
      className: styles['partial-rect'],
      x: "3",
      y: "7",
      width: "10",
      height: "2",
      rx: "1",
      fill: "var(--White)"
    })]
  }));
};
var Checkbox = function (_a) {
  var _b;
  var isChecked = _a.isChecked,
    _c = _a.className,
    className = _c === void 0 ? '' : _c,
    onChange = _a.onChange,
    isDisabled = _a.isDisabled,
    children = _a.children,
    _d = _a.isPartial,
    isPartial = _d === void 0 ? false : _d,
    _e = _a.isError,
    isError = _e === void 0 ? false : _e,
    _f = _a.variant,
    variant = _f === void 0 ? 'default' : _f,
    _g = _a.menuOptions,
    menuOptions = _g === void 0 ? [] : _g,
    rest = __rest(_a, ["isChecked", "className", "onChange", "isDisabled", "children", "isPartial", "isError", "variant", "menuOptions"]);
  var _h = useState(false),
    isMenuOpen = _h[0],
    setIsMenuOpen = _h[1];
  var _className = classNames(styles.base, (_b = {}, _b[styles['table-checkbox']] = variant === 'tableCheckbox', _b[styles['table-header']] = variant === 'tableHeader', _b[styles['checkbox-disabled']] = isDisabled && !isError, _b[styles['checkbox-on']] = isChecked && !isError && !isPartial, _b[styles['checkbox-off']] = !isChecked && !isError && !isPartial, _b[styles['checkbox-partial']] = isPartial && !isError, _b[styles['checkbox-error']] = isError, _b), className);
  var handleClick = function (e) {
    if (variant !== 'tableHeader') {
      onChange && onChange(!isChecked, e);
    }
  };
  return jsxs("label", __assign({
    className: _className
  }, {
    children: [jsx("input", __assign({
      onChange: handleClick,
      className: styles['checkbox'],
      disabled: isDisabled,
      type: "checkbox"
    }, rest)), variant === 'tableHeader' ? jsx(Popover, __assign({
      trigger: "click",
      isAppendedToBody: true,
      onVisibleChange: function (isOpen) {
        setIsMenuOpen(isOpen);
      },
      visible: isMenuOpen,
      container: jsxs(Fragment, {
        children: [jsx(CheckboxContainer, {}), jsx("svg", __assign({
          width: "9",
          height: "5",
          viewBox: "0 0 9 5",
          fill: "none",
          xmlns: "http://www.w3.org/2000/svg",
          className: styles['checkbox-arrow']
        }, {
          children: jsx("path", {
            d: "M4.5 5L0.602887 0.499999L8.39711 0.5L4.5 5Z",
            fill: "var(--Primary_Blue)"
          })
        }))]
      }),
      popoverClass: styles['table-header-menu']
    }, {
      children: jsx("ul", {
        children: menuOptions === null || menuOptions === void 0 ? void 0 : menuOptions.map(function (item) {
          var _a;
          return jsx("li", __assign({
            className: classNames((_a = {}, _a[styles['active-option']] = item.isActive, _a[styles['disabled-option']] = item.isDisabled, _a)),
            onClick: function (e) {
              if (!item.isDisabled && item.onClick) {
                item.onClick(e);
                setIsMenuOpen(false);
              }
            }
          }, {
            children: item.label
          }), item === null || item === void 0 ? void 0 : item.label);
        })
      })
    })) : jsx(CheckboxContainer, {}), variant === 'default' && jsx(Typography, __assign({
      variant: 'Regular_14'
    }, {
      children: children
    }))]
  }));
};

export { Checkbox };
//# sourceMappingURL=index.js.map
