import React, { ReactNode } from 'react';
type customResolutionColumn = number | false | null;
type columnsType = number | false;
export interface FlexLayoutProps {
    /** All the React elements that should be placed on the layout */
    children?: ReactNode;
    /** Custom ClassName for overriding styles */
    className?: string;
    /** Custom styles object */
    style?: React.CSSProperties;
    /** Is it a layout container or item of an internal grid (for example, inside dialogs, cards or right panels */
    isInternalLayout?: boolean;
    /** Is it a container layout? Does it have children? If false, it's a layout item */
    isContainer?: boolean;
    /** How many columns should it take? for regular layout maximum is 12, for internal layout maximum is 8, enter false for full page width  */
    columns?: columnsType;
    /** Same as column, but for medium resolution, if omitted. columns value will be taken */
    mediumResolutionColumns?: customResolutionColumn;
    /** Same as column, but for small resolution, if omitted. columns value will be taken */
    smallResolutionColumns?: customResolutionColumn;
    /** For Layout container, layout direction, should the elements be aligned in a row or a column */
    flexDirection?: 'row' | 'column';
    /** For Layout container, should default padding removed? */
    isRemovePadding?: boolean;
}
/** Responsive layout */
export declare const FlexLayout: ({ children, className, isInternalLayout, isContainer, columns, flexDirection, mediumResolutionColumns, smallResolutionColumns, isRemovePadding, ...rest }: FlexLayoutProps) => JSX.Element;
export {};
