import { __rest, __makeTemplateObject, __assign } from 'tslib';
import { jsx } from 'react/jsx-runtime';
import classNames from 'classnames';
import { css } from '@emotion/css';
import styles from './FlexLayout.module.scss.js';
import { useThemeProvider } from '../ThemeProvider/index.js';

var calculateColumnWidth = function (columns, screenResolution, mediumResolutionColumns, smallResolutionColumns, isInternalLayout) {
  var numberOfColumns = screenResolution === 'mediumResolution' && mediumResolutionColumns !== null ? mediumResolutionColumns : screenResolution === 'smallResolution' && smallResolutionColumns !== null ? smallResolutionColumns : columns;
  var maxGridColumns = isInternalLayout ? 8 : 12;
  return numberOfColumns === false ? 'calc(100% + (2 * var(--horizontal-padding)))' : "calc((((100% - ".concat((maxGridColumns - 1) * 24, "px) / ").concat(maxGridColumns, ") * ").concat(numberOfColumns, ") + ").concat((numberOfColumns - 1) * 24, "px)");
};
/** Responsive layout */
var FlexLayout = function (_a) {
  var _b;
  var children = _a.children,
    _c = _a.className,
    className = _c === void 0 ? '' : _c,
    _d = _a.isInternalLayout,
    isInternalLayout = _d === void 0 ? false : _d,
    _e = _a.isContainer,
    isContainer = _e === void 0 ? false : _e,
    _f = _a.columns,
    columns = _f === void 0 ? false : _f,
    _g = _a.flexDirection,
    flexDirection = _g === void 0 ? 'row' : _g,
    _h = _a.mediumResolutionColumns,
    mediumResolutionColumns = _h === void 0 ? null : _h,
    _j = _a.smallResolutionColumns,
    smallResolutionColumns = _j === void 0 ? null : _j,
    _k = _a.isRemovePadding,
    isRemovePadding = _k === void 0 ? false : _k,
    rest = __rest(_a, ["children", "className", "isInternalLayout", "isContainer", "columns", "flexDirection", "mediumResolutionColumns", "smallResolutionColumns", "isRemovePadding"]);
  var screenResolution = useThemeProvider().screenResolution;
  var customClass = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    flex-direction: ", ";\n    width: ", ";\n  "], ["\n    flex-direction: ", ";\n    width: ", ";\n  "])), flexDirection, isContainer ? '100%' : calculateColumnWidth(columns, screenResolution, mediumResolutionColumns, smallResolutionColumns, isInternalLayout));
  var _className = classNames(styles.base, customClass, className, (_b = {}, _b[styles['internal-layout']] = isInternalLayout, _b[styles['container']] = isContainer, _b[styles['column-direction']] = flexDirection === 'column', _b[styles['small-resolution']] = screenResolution === 'smallResolution', _b[styles['default-padding']] = !isRemovePadding, _b[styles['off-grid']] = columns === false, _b));
  return jsx("div", __assign({
    className: _className
  }, rest, {
    children: children
  }));
};
var templateObject_1;

export { FlexLayout };
//# sourceMappingURL=index.js.map
