import React, { MouseEventHandler, ReactNode } from 'react';
export declare const iconTypeMapper: {
    error: {
        icon: React.SFC<React.SVGProps<SVGSVGElement>>;
    };
    warning: {
        icon: React.SFC<React.SVGProps<SVGSVGElement>>;
    };
    success: {
        icon: React.SFC<React.SVGProps<SVGSVGElement>>;
    };
    info: {
        icon: React.SFC<React.SVGProps<SVGSVGElement>>;
    };
    urgent: {
        icon: React.SFC<React.SVGProps<SVGSVGElement>>;
    };
};
export type NotificationType = 'success' | 'error' | 'warning' | 'info' | 'urgent';
export type NotificationVariant = 'primary' | 'secondary';
export interface NotificationProps {
    /** Notification Type */
    type: NotificationType;
    /** Notification variant */
    variant?: NotificationVariant;
    /** Children */
    children: ReactNode;
    /** In case of expandable Notification, It's the expanded section */
    moreInfo?: ReactNode;
    /** If this Notification closeable, It's the callback */
    onClose?: MouseEventHandler<HTMLButtonElement>;
    /** Custom classname */
    className?: string;
    /** Custom classname for moreInfo part */
    moreInfoClassName?: string;
    /** moreInfoWrapper classname */
    moreInfoWrapperClassName?: string;
}
/** Notification */
export declare const Notification: ({ type, variant, children, moreInfoClassName, moreInfo, onClose, className, moreInfoWrapperClassName, ...rest }: NotificationProps) => JSX.Element;
