import { __rest, __assign } from 'tslib';
import { jsxs, jsx, Fragment } from 'react/jsx-runtime';
import { usePopperTooltip } from 'react-popper-tooltip';
import styles from './Popover.module.scss.js';
import ReactDOM from 'react-dom';
import classNames from 'classnames';

/** basic popover  */
var Popover = function (_a) {
  var container = _a.container,
    containerClass = _a.containerClass,
    _b = _a.trigger,
    trigger = _b === void 0 ? 'click' : _b,
    popoverClass = _a.popoverClass,
    children = _a.children,
    _c = _a.isAppendedToBody,
    isAppendedToBody = _c === void 0 ? false : _c;
    _a.placement;
    var rest = __rest(_a, ["container", "containerClass", "trigger", "popoverClass", "children", "isAppendedToBody", "placement"]);
  var _e = usePopperTooltip(__assign({
      trigger: trigger
    }, rest)),
    getArrowProps = _e.getArrowProps,
    getTooltipProps = _e.getTooltipProps,
    setTooltipRef = _e.setTooltipRef,
    setTriggerRef = _e.setTriggerRef,
    visible = _e.visible;
  var tooltipWrapper = jsxs("div", __assign({
    ref: setTooltipRef
  }, getTooltipProps({
    className: classNames(styles.base, popoverClass)
  }), {
    children: [children, jsx("div", __assign({}, getArrowProps({
      className: styles['tooltip-arrow']
    })))]
  }));
  return jsxs(Fragment, {
    children: [jsx("span", __assign({
      className: classNames(styles['tooltip-wrapper'], containerClass, {
        active: visible
      }),
      ref: setTriggerRef
    }, {
      children: container
    })), visible && (isAppendedToBody ? ReactDOM.createPortal(tooltipWrapper, document.body) : tooltipWrapper)]
  });
};

export { Popover };
//# sourceMappingURL=index.js.map
