import { __rest, __assign } from 'tslib';
import { jsx, jsxs } from 'react/jsx-runtime';
import classNames from 'classnames';
import styles from './RadioButton.module.scss.js';
import { Typography } from '../Typography/index.js';

var RadioButton = function (_a) {
  var isChecked = _a.isChecked,
    className = _a.className,
    onChange = _a.onChange,
    _b = _a.isDisabled,
    isDisabled = _b === void 0 ? false : _b,
    children = _a.children,
    rest = __rest(_a, ["isChecked", "className", "onChange", "isDisabled", "children"]);
  var _className = classNames(styles.base, className);
  var _radioButtonStateClass = classNames(styles['radio-button'], isDisabled && styles['radio-disabled'], isChecked && styles['radio-active'], !isChecked && !isDisabled && styles['radio-unchecked']);
  return jsx("label", __assign({
    className: _className
  }, {
    children: jsxs("span", __assign({
      className: _radioButtonStateClass
    }, {
      children: [jsx("input", __assign({
        className: styles['radio-input'],
        onChange: function (e) {
          return onChange(!isChecked, e);
        },
        checked: isChecked,
        type: "radio",
        disabled: isDisabled
      }, rest)), jsxs("svg", {
        children: [jsx("circle", {
          stroke: "1",
          cx: "8.5",
          cy: "8.5",
          r: "8",
          className: styles['outer-circle']
        }), jsx("circle", {
          stroke: "none",
          cx: "8.5",
          cy: "8.5",
          r: "1",
          className: styles['inner-circle']
        })]
      }), jsx(Typography, __assign({
        variant: 'Regular_14',
        className: styles['label-text']
      }, {
        children: children
      }))]
    }))
  }));
};

export { RadioButton };
//# sourceMappingURL=index.js.map
