import { __assign } from 'tslib';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useState } from 'react';
import styles from './FilterPanel.module.scss.js';
import { ReactComponent } from '@netapp/icons/ic_filter.svg';
import { ButtonBase } from '../ButtonBase/index.js';
import classNames from 'classnames';
import { Popover } from '../Popover/index.js';
import { Checkbox } from '../Checkbox/index.js';

var FilterPanel = function (_a) {
  var _b = _a.column,
    filterState = _b.filterState,
    filterOptions = _b.filterOptions,
    updateColumnFilter = _b.updateColumnFilter,
    setIsOpen = _a.setIsOpen;
  var _c = useState((filterState === null || filterState === void 0 ? void 0 : filterState.values) || {}),
    internalState = _c[0],
    setInternalState = _c[1];
  return jsxs("div", __assign({
    className: styles['filter-panel']
  }, {
    children: [jsx("div", __assign({
      className: styles['filter-content']
    }, {
      children: filterOptions && Array.isArray(filterOptions) && filterOptions.length > 0 && filterOptions.map(function (_a) {
        var value = _a.value,
          label = _a.label;
        return jsx(Checkbox, __assign({
          isChecked: internalState[String(value)] || false,
          className: styles['checkbox-container'],
          onChange: function () {
            var _a;
            return setInternalState(__assign(__assign({}, internalState), (_a = {}, _a[String(value)] = !internalState[String(value)], _a)));
          }
        }, {
          children: jsx("span", {
            children: label
          })
        }), value);
      })
    })), jsxs("div", __assign({
      className: styles['buttons-row']
    }, {
      children: [jsx(ButtonBase, __assign({
        onClick: function () {
          updateColumnFilter && updateColumnFilter(internalState);
          setIsOpen(false);
        }
      }, {
        children: "Apply"
      })), jsx(ButtonBase, __assign({
        onClick: function () {
          setInternalState({});
          updateColumnFilter && updateColumnFilter({});
          setIsOpen(false);
        }
      }, {
        children: "Clear"
      }))]
    }))]
  }));
};
var FilterButton = function (_a) {
  var _b;
  var column = _a.column;
  var _c = useState(false),
    isOpen = _c[0],
    setIsOpen = _c[1];
  return jsx(Popover, __assign({
    visible: isOpen,
    isAppendedToBody: true,
    popoverClass: styles['filter-panel-wrapper'],
    container: jsx(ButtonBase, __assign({
      onClick: function () {
        return setIsOpen(function (prev) {
          return !prev;
        });
      }
    }, {
      children: jsx(ReactComponent, {})
    })),
    containerClass: classNames(styles['filter-trigger-button'], (_b = {}, _b[styles['opened']] = isOpen, _b))
  }, {
    children: jsx(FilterPanel, {
      column: column,
      setIsOpen: setIsOpen
    })
  }));
};

export { FilterButton, FilterPanel };
//# sourceMappingURL=FilterPanel.js.map
