import { ReactNode } from 'react';
import './ThemeProvider.scss';
export interface ThemeProviderProps {
    /** Your app */
    children: ReactNode;
    /** Is Your app will be rendered as an Iframe? */
    isIframe: boolean;
}
interface sharedContextProps {
    theme: string;
    screenResolution: ResolutionType;
}
export type ResolutionType = 'largeResolution' | 'mediumResolution' | 'smallResolution';
/** ThemeProvider should wrap your app in index.js, it is used to declare the css variables of the design system, including animations, colors and shadow */
export declare const ThemeProvider: ({ children, isIframe, }: ThemeProviderProps) => JSX.Element;
export declare const useThemeProvider: () => sharedContextProps;
export {};
