import { ReactNode } from 'react';
import { PopoverProps } from '../Popover';
export interface TooltipInfoProps extends Omit<PopoverProps, 'container'> {
    /** popover trigger */
    trigger?: 'hover' | 'click';
    /** popover custom classname */
    popoverClass?: string;
    /** trigger element custom classname */
    className?: string;
    /** Label */
    label?: ReactNode;
    /** Preferred placement of the tooltip */
    placement?: 'top' | 'right' | 'left' | 'bottom';
    /** Children */
    children: ReactNode;
}
/** Tooltip info  */
export declare const TooltipInfo: ({ popoverClass, children, trigger, className, label, ...rest }: TooltipInfoProps) => JSX.Element;
