import React, { ReactNode } from "react";
export type TypographyVariant = 'Regular_40' | 'Semibold_32' | 'Regular_32' | 'Semibold_24' | 'Regular_24' | 'Semibold_20' | 'Regular_20' | 'Semibold_16' | 'Regular_16' | 'Regular_14' | 'Semibold_14' | 'Semibold_13' | 'Regular_13' | 'Regular_12';
export interface TypographyProps extends React.HTMLAttributes<HTMLDivElement> {
    /** Title or Body Text */
    children: ReactNode;
    /** Center */
    isCenter?: boolean;
    /** Ellipses */
    isEllipsis?: boolean;
    /** NoWrap */
    isNowrap?: boolean;
    /** ClassName */
    className?: string;
    /** Variant */
    variant?: TypographyVariant;
    /** Custom Element */
    Component?: React.ElementType;
    /** custom styles object */
    style?: React.CSSProperties;
    /** Color of the text, must be vaild css color definition*/
    color?: string;
}
/** Typography */
export declare const Typography: React.ForwardRefExoticComponent<TypographyProps & React.RefAttributes<unknown>>;
