import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _extends from '@babel/runtime/helpers/extends';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default, { useState } from 'react';
import DatePickerComp from 'react-datepicker';
import TextInput from '../TextInput/index.js';
import SvgArrowLeftSingle from '../../assets/svgs/arrow-left-single.svg.js';
import SvgArrowLeftDouble from '../../assets/svgs/arrow-left-double.svg.js';
import SvgArrowRightSingle from '../../assets/svgs/arrow-right-single.svg.js';
import SvgArrowRightDouble from '../../assets/svgs/arrow-right-double.svg.js';
import './datePicker.scss.js';
import './reactDatePicker.scss.js';
import ButtonBase from '../ButtonBase/index.js';
import Text from '../Text/index.js';
import PropTypes from 'prop-types';

var _excluded = ["isCalendarOpen"],
  _excluded2 = ["textFieldProps"];
var CustomHeader = function CustomHeader(isTwoMonths) {
  return function (_ref) {
    var monthDate = _ref.monthDate,
      decreaseMonth = _ref.decreaseMonth,
      increaseMonth = _ref.increaseMonth,
      prevMonthButtonDisabled = _ref.prevMonthButtonDisabled,
      nextMonthButtonDisabled = _ref.nextMonthButtonDisabled,
      customHeaderCount = _ref.customHeaderCount,
      decreaseYear = _ref.decreaseYear,
      nextYearButtonDisabled = _ref.nextYearButtonDisabled,
      prevYearButtonDisabled = _ref.prevYearButtonDisabled,
      increaseYear = _ref.increaseYear;
    var dateText = monthDate.toLocaleDateString('en-US', {
      year: 'numeric',
      month: 'long'
    });
    return /*#__PURE__*/React__default.createElement("div", {
      className: "Suc-calendar-custom-header ".concat(customHeaderCount === 1 ? 'Suc-multiple-months' : '')
    }, /*#__PURE__*/React__default.createElement("div", {
      className: "Suc-actions-before"
    }, customHeaderCount === 0 && /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(ButtonBase, {
      type: "button",
      onClick: function onClick(e) {
        decreaseYear();
      },
      disabled: prevYearButtonDisabled
    }, /*#__PURE__*/React__default.createElement(SvgArrowLeftDouble, null)), /*#__PURE__*/React__default.createElement(ButtonBase, {
      type: "button",
      onClick: function onClick(e) {
        decreaseMonth();
        decreaseMonth();
      },
      disabled: prevMonthButtonDisabled
    }, /*#__PURE__*/React__default.createElement(SvgArrowLeftSingle, null)))), /*#__PURE__*/React__default.createElement(Text, {
      fontWeight: 600,
      className: "Suc-date-text"
    }, dateText), /*#__PURE__*/React__default.createElement("div", {
      className: "Suc-actions-after"
    }, (customHeaderCount === 1 || !isTwoMonths) && /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(ButtonBase, {
      type: "button",
      onClick: function onClick(e) {
        increaseMonth();
        increaseMonth();
      },
      disabled: nextMonthButtonDisabled
    }, /*#__PURE__*/React__default.createElement(SvgArrowRightSingle, null)), /*#__PURE__*/React__default.createElement(ButtonBase, {
      type: "button",
      onClick: function onClick(e) {
        increaseYear();
      },
      disabled: nextYearButtonDisabled
    }, /*#__PURE__*/React__default.createElement(SvgArrowRightDouble, null)))));
  };
};
var DateTextInput = function DateTextInput(_ref2) {
  var isCalendarOpen = _ref2.isCalendarOpen,
    props = _objectWithoutProperties(_ref2, _excluded);
  return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(TextInput, _extends({
    removeBottomMargin: true
  }, props)), /*#__PURE__*/React__default.createElement("div", {
    className: "Suc-drop-down-indicator ".concat(isCalendarOpen ? 'Suc-open' : '')
  }));
};

/** Date Picker and date range - see props at https://github.com/Hacker0x01/react-datepicker/blob/master/docs/datepicker.md  */
var DatePicker = function DatePicker(_ref3) {
  var textFieldProps = _ref3.textFieldProps,
    props = _objectWithoutProperties(_ref3, _excluded2);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isCalendarOpen = _useState2[0],
    setIsCalendarOpen = _useState2[1];
  return /*#__PURE__*/React__default.createElement("div", {
    className: 'Suc-date-picker'
  }, /*#__PURE__*/React__default.createElement(DatePickerComp, _extends({
    customInput: /*#__PURE__*/React__default.createElement(DateTextInput, _extends({
      isCalendarOpen: isCalendarOpen
    }, textFieldProps)),
    renderCustomHeader: CustomHeader(props.monthsShown > 1),
    disabledKeyboardNavigation: true,
    wrapperClassName: 'Suc-date-input',
    clearButtonClassName: 'Suc-clear-button',
    onCalendarClose: function onCalendarClose() {
      return setIsCalendarOpen(false);
    },
    onCalendarOpen: function onCalendarOpen() {
      return setIsCalendarOpen(true);
    }
  }, props)));
};
DatePicker.propTypes = {
  /** custom props to the text field */
  textFieldProps: PropTypes.object
};
DatePicker.defaultProps = {
  textFieldProps: {}
};

export { DatePicker as default };
//# sourceMappingURL=index.js.map
